local KeyBindings = FlexBar2.OO.Mixin 
{
	"ValidateBinding",
	"SetBinding",
	"KeyBindings_Update",
};

function KeyBindings:Activate()
	if(type(self.Settings.Bindings) == "table") then
		for n,v in ipairs(self.Settings.Bindings) do
			self:SetBinding(v);
		end
	else
		self.Settings.Bindings = {};
	end
	self:RegisterEvent("UPDATE_BINDINGS", "KeyBindings_Update");
end

function KeyBindings:ValidateBinding(Key)
	return AceLibrary("AceConsole-2.0").keybindingValidateFunc(Key)
end

function KeyBindings:SetBinding(Key, save)
	if(self:ValidateBinding(Key)) then
		SetBindingClick(Key, "FB2_BTN_" .. self.uid, "LeftButton");
		if(save) then
			table.insert(self.Settings.Bindings, Key);
		end
	end
end

function KeyBindings:KeyBindings_Update()
	for n,v in ipairs(self.Settings.Bindings) do
		if(GetBindingAction(v) ~= "FB2_BTN_" .. self.uid) then
			table.remove(self.Settings.Bindings, n);
		end
	end
end

FlexBar2:RegisterButtonClass(KeyBindings);
